<template>
    <div>
        <audio id="audio_remote" autoplay="autoplay"> </audio>
        <div>
            <q-btn class="join-button-size" :color="connected ? 'white bg-red' : 'white bg-green'" :disable="connecting"
                @click="buttonPressed">
                <div class="button-visual">
                    <q-spinner v-if="connecting" />
                    <q-icon v-else name="public" />
                </div>
                <div class="button-txt">
                    {{ connected ? $t("conference.online_joined") : connecting ? $t("conference.online_joining") :
                            $t("conference.online_join")
                    }}
                </div>
            </q-btn>
        </div>

        <p v-if="permissionsIssue" class="join-button-size" style="color:red; text-align:center; padding-top:5px;">
            {{ $t("conference.online_allow") }}</p>

        <q-dialog v-model="showPermissionsAlert">
            <q-card>
                <q-card-section>
                    <div class="text-h6">{{ $t("conference.online_not_compatible_title") }}</div>
                </q-card-section>

                <q-card-section class="q-pt-none">
                    {{ $t("conference.online_not_compatible") }}
                </q-card-section>

                <q-card-actions align="right">
                    <q-btn flat label="OK" color="primary" v-close-popup />
                </q-card-actions>
            </q-card>
        </q-dialog>
    </div>
</template>

<script>

const JsSIP = require("jssip");

export default {
    props: {
        callWhenMounted: {
            required: true
        },
        getDetailsAction: {
            required: true
        }
    },
    data()
    {
        return {
            conf: null,
            userAgent: null,
            session: null,
            connecting: false,
            connected: false,
            muted: false,
            permissionsIssue: false,
            showPermissionsAlert: false,
            myCandidateTimeout: null,
            mediastream: null
        };
    },
    mounted()
    {
        this.setup();
    },
    beforeDestroy()
    {
        try 
        {
            this.hangup();
            if (this.userAgent)
            {
                this.userAgent.stop();
            }
            this.mediastream.getTracks().forEach(function (track)
            {
                track.stop();
            });
        }
        catch (error)
        {
            console.log("error while destroying webrtc: ")
        }

    },
    computed: {
        // checks for browser's technical ability to use mic/video
        hasGetUserMedia()
        {
            return !!(navigator.mediaDevices && navigator.mediaDevices.getUserMedia);
        },
    },
    methods: {
        async setup()
        {
            this.conf = await this.getDetailsAction();
            if (this.callWhenMounted)
            {
                await this.startRTC();
                this.call();
            }
        },
        async startRTC()
        {
            if (!this.hasGetUserMedia) 
            {
                this.showPermissionsAlert = true;
                return;
            }

            if (this.conf == null)
            {
                this.conf = await this.getDetailsAction();
            }

            if (this.mediastream) return // already setup

            try 
            {
                this.mediastream = await navigator.mediaDevices.getUserMedia({ 'audio': true });

                var socket = new JsSIP.WebSocketInterface(this.conf.FreeswitchWS);
                var configuration = {
                    sockets: [socket],
                    uri: this.conf.FreeswitchUserAddress,
                    password: this.conf.FreeswitchUserPW,
                    display_name: this.conf.FreeswitchExtraData
                    // displayname field used to pass contextual data to freeswitch (e.g. conference, firebase user IDs)
                };
                this.userAgent = new JsSIP.UA(configuration);
                this.userAgent.start();
            }
            catch (error) 
            {
                if (error.name == 'NotAllowedError')
                {
                    this.permissionsIssue = true;
                }
                console.log("Error setting up stream");
            }

        },
        async buttonPressed()
        {
            if (this.connecting) return;

            if (this.connected)
            {
                // disconnect from call
                this.hangup();
            }
            else
            {
                await this.startRTC();
                this.call();
            }
        },
        async call()
        {

            try
            {
                if (!this.userAgent)
                {
                    await this.startRTC();
                    if (!this.userAgent) return; // setup failed
                }

                let context = this;

                var eventHandlers = {
                    'progress': function (e)
                    {
                        console.log('call is in progress');
                        console.log(e)
                    },
                    'failed': function (e)
                    {
                        context.connecting = false;
                        context.connected = false;
                        console.log('call failed ');
                        console.log(e);
                        if (e.cause === "User Denied Media Access")
                        {
                            console.log("no mic")
                            context.permissionsIssue = true;
                        }
                    },
                    'ended': function (e)
                    {
                        context.connecting = false;
                        context.connected = false;
                        console.log('call ended');
                        console.log(e);
                    },
                    'confirmed': function (e)
                    {
                        console.log('call confirmed');
                        console.log(e)
                        context.permissionsIssue = false;
                    },
                    'icecandidate': function (candidate)
                    {
                        if (context.myCandidateTimeout != null)
                        {
                            clearTimeout(context.myCandidateTimeout);
                        }
                        // 5 seconds timeout after the last icecandidate received!
                        context.myCandidateTimeout = setTimeout(candidate.ready, 5000);
                    }
                };

                var options = {
                    'mediaStream': this.mediastream,
                    'eventHandlers': eventHandlers,
                    'mediaConstraints': { 'audio': true },
                    'sessionTimersExpires': 120,
                    'pcConfig': {
                        'iceServers': [
                            {
                                'urls': ['stun:stun.l.google.com:19302', 'stun:stun1.l.google.com:19302']
                            }
                        ]
                    }
                };

                this.session = this.userAgent.call('070492', options);

                this.connecting = true;

                this.session.connection.addEventListener('addstream', (e) =>
                {
                    this.connecting = false;
                    this.connected = true;
                    let audioRemote = document.getElementById("audio_remote");
                    audioRemote.srcObject = e.stream
                })
            }
            catch (error)
            {
                console.log(error);
            }
        },
        hangup()
        {
            console.log("hangup")
            if (this.userAgent)
            {
                this.userAgent.terminateSessions();
            }
        },
        handleMute()
        {
            if (!this.session) return;

            if (this.muted)
            {
                this.session.unmute({ audio: true });
                this.muted = false;
            }
            else
            {
                this.session.mute({ audio: true });
                this.muted = true;
            }
        }
    }
};
</script>